<?php
/**
 * Created by PhpStorm.
 * User: Administrator
 * Date: 2015/7/23
 * Time: 14:28
 */
namespace myapp\code\core\Api\V1\models\wish;
use yii\db\ActiveRecord;

class WishOrder extends ActiveRecord
{

    public static function getDb(){
        return \Yii::$app->wishDb;
    }

    public static function tableName()
    {
        return 'wish_order';
    }


    public  function fields(){

        return [
            'id',
            'platform_order_id',
            'platform_order_states',
            'wish_name',
            'transaction_id',
            'sku',
            'qty',
            'adapter',
            'spu',
            'spu_atrribute',
            'order_total',
            'spu_price',
            'spu_shipping',
            'spu_name',
            'sku_china_name',
            'spu_image_url',
            'last_updated',
            'days_to_fulfill',
            'hours_to_fulfill',
            'order_create_time',
            'customer_name',
            'customer_country',
            'customer_province',
            'customer_city',
            'customer_street_address1',
            'customer_street_address2',
            'customer_zipcode',
            'customer_phone',
            'customer_note',
            'shipping_provider',
            'tracking_number',
            'warehouse_id',
            'real_ship_cost',
            'real_ship_cost_currency',


        ];
    }
}



?>