<?php

/* @var $this yii\web\View */

$this->title = '复杂美科技消息队列管理系统（日志，订单，邮件，用户交互）';
?>
<div class="site-index">

    <div class="jumbotron">
        <h1>欢迎!</h1>

        <p class="lead">复杂美科技消息队列管理系统（日志，订单，邮件，用户交互）.</p>

        <p><a class="btn btn-lg btn-success" href="http://logsystemadmin.mkglasses.com/rabbit/">开始查看队列</a></p>
    </div>

    <div class="body-content">

        <div class="row">
            <div class="col-lg-4">
                <h2>服务架构和使用场景</h2>

                <p>项目后端支撑采用rabbitmq+，logstash分析,elasticsearch全文搜索,kibana创建支持海量数据，高并发请求.</p>
                <p> 支持应用在功能内部，邮件群发，消息日志，订单系统，用户积分活动等交互热数据操作.</p>

                <p><a class="btn btn-default" href="/doc/fwjg/">详情 &raquo;</a></p>
            </div>
            <div class="col-lg-4">
                <h2>项目接口文档</h2>

                <code>{                   "message": "rabbit insert Ok!",
                    "action": "insert",
                    "rabbitdata": {  "r": "api/page",
                    "signature": "44D027A88F0D44B12E1DF90691B491C0",
                    "timestamp": "1",
                    "rabbitdata": "nihao"  },
                    "code": 100 }</code>

                <p><a class="btn btn-default" href="https://dev.33.cn/yanglin/logSystem-advance">项目文档 &raquo;</a></p>
            </div>
            <div class="col-lg-4">
                <h2>版本介绍</h2>

                <p>该版本v1.0为测试先行版，发布功能有:nginx消息采集，消息队列部署，查询消费消息，检索队列消息。下版本预计退出计划服务，任务计划，支持队列消息派送关联操作其他服务端数据，可能引入锁操作.</p>

                <p><a class="btn btn-default" href="/doc/bbjs">版本预览和注册使用 &raquo;</a></p>
            </div>
        </div>

    </div>
</div>
